<?php


// Determine what locale to use
switch (PHP_OS)
{
	case 'WINNT':
	case 'WIN32':
		$locale = 'finnish';
		break;

	case 'FreeBSD':
	case 'NetBSD':
	case 'OpenBSD':
		$locale = 'fi_FI.ISO8859-1';
		break;

	default:
		$locale = 'fi_FI';
		break;
}

// Attempt to set the locale
setlocale(LC_CTYPE, $locale);


// Language definitions for frequently used strings
$lang_common = array(

// Text orientation and encoding
'lang_direction'	=>	'ltr',	// ltr (Left-To-Right) or rtl (Right-To-Left)
'lang_encoding'		=>	'iso-8859-1',
'lang_multibyte'	=>	false,

// Notices
'Bad request'		=>	'Bad request. The link you followed is incorrect or outdated.',
'No view'		=>	'Sinulla ei ole lupaa seurata nit foorumeita.',
'No permission'		=>	'Sinulla ei ole lupaa sivun lataamiseen.',
'Bad referrer'		=>	'Bad HTTP_REFERER. You were referred to this page from an unauthorized source. If the problem persists please make sure that \'Base URL\' is correctly set in Admin/Options and that you are visiting the forum by navigating to that URL. More information regarding the referrer check can be found in the PunBB documentation.',

// Topic/forum indicators
'New icon'		=>	'There are new posts',
'Normal icon'		=>	'<!-- -->',
'Closed icon'		=>	'Tm kanava on suljettu',
'Redirect icon'		=>	'Redirected forum',

// Miscellaneous
'Announcement'		=>	'Tiedoite',
'Options'		=>	'Asetukset',
'Actions'		=>	'Toimenpiteet',
'Submit'		=>	'Lhet',	// "name" of submit buttons
'Ban message'		=>	'Olet porttikiellossa tll foorumilla.',
'Ban message 2'		=>	'Pset porttikiellosta',
'Ban message 3'		=>	'Porttikiellon mrj jtti sinulle seuraavan viestin:',
'Ban message 4'		=>	'Tiedustelut foorumin yllpitjlle',
'Never'			=>	'Ei koskaan',
'Today'			=>	'Tnn',
'Yesterday'		=>	'Eilen',
'Info'			=>	'Info',		// a common table header
'Go back'		=>	'Siirry takaisin',
'Maintenance'		=>	'Yllpito',
'Redirecting'		=>	'Uudelleenohjaus',
'Click redirect'	=>	'Klikkaa tst, jos kyllstyit odottamaan (tai jos selaimesi ei automaatisesti seuraa uudelleenohjausta)',
'on'			=>	'on',		// as in "BBCode is on"
'off'			=>	'off',
'Invalid e-mail'	=>	'Antamasi shkpostiosoite on virheellinen.',
'required field'	=>	'on tieto, joka tytyy tytt tll lomakkeella.',	// for javascript form validation
'Last post'		=>	'Viimeinen viesti',
'by'			=>	'by',	// as in last post by someuser
'New posts'		=>	'Uudet&nbsp;viestit',	// the link that leads to the first new post (use &nbsp; for spaces)
'New posts info'	=>	'Mene ensimiseen uuteen viestiin tss viestiketjussa.',	// the popup text for new posts links
'Username'		=>	'Kyttjtunnus',
'Password'		=>	'Salasana',
'E-mail'		=>	'E-mail',
'Send e-mail'		=>	'Lhet shkpostia',
'Moderated by'		=>	'Moderaattori',
'Registered'		=>	'Rekisterity',
'Subject'		=>	'Aihe',
'Message'		=>	'Viesti',
'Topic'			=>	'Aihe',
'Forum'			=>	'Kanava',
'Posts'			=>	'Viestit',
'Replies'		=>	'Vastattu',
'Author'		=>	'Kirjoittaja',
'Pages'			=>	'Sivuja',
'BBCode'		=>	'BBCode',	// You probably shouldn't change this
'img tag'		=>	'[img] tag',
'Smilies'		=>	'Smilies',
'and'			=>	'and',
'Image link'		=>	'image',	// This is displayed (i.e. <image>) instead of images when "Show images" is disabled in the profile
'wrote'			=>	'kirjoitti',	// For [quote]'s
'Code'			=>	'Koodi',		// For [code]'s
'Mailer'		=>	'Mailer',	// As in "MyForums Mailer" in the signature of outgoing e-mails
'Important information'	=>	'Trke tietoa',
'Write message legend'	=>	'Kirjoita viesti ja lhet',

// Title
'Title'			=>	'Titteli',
'Member'		=>	'Rekisterity kyttj',	// Default title
'Moderator'		=>	'Moderaattori',
'Administrator'		=>	'Yllpitj',
'Banned'		=>	'Porttikielto',
'Guest'			=>	'Vieras',

// Stuff for include/parser.php
'BBCode error'		=>	'Viestiss oleva muotoilukoodi on virheellinen.',
'BBCode error 1'	=>	'[/quote] tagin alku puuttuu.',
'BBCode error 2'	=>	'[code] tagin loppu puuttuu.',
'BBCode error 3'	=>	'[/code] tagin alku puuttuu.',
'BBCode error 4'	=>	'[quote] tagin loppu puuttuu.',
'BBCode error 5'	=>	'[/quote] tagin alku puuttuu.',

// Stuff for the navigator (top of every page)
'Index'			=>	'Sisllysluettelo',
'User list'		=>	'Jsenet',
'Rules'			=>  	'Snnt',
'Search'		=>  	'Etsi',
'Register'		=>  	'Kyttjtunnus tst!',
'Login'			=>  	'Ky peremmlle',
'Not logged in'		=>  	'Et ole kirjautunut kyttjksi.',
'Profile'		=>	'Omat asetukset',
'Logout'		=>	'Logout',
'Logged in as'		=>	'Olet kirjautunut tunnuksella',
'Admin'			=>	'Administration',
'Last visit'		=>	'Edellinen kynti',
'Show new posts'	=>	'Nyt edellisen kynnin jlkeen saapuneet viestit ',
'Mark all as read'	=>	'Merkitse kaikki viestiketjut luetuiksi',
'Link separator'	=>	'',	// The text that separates links in the navigator

// Stuff for the page footer
'Board footer'		=>	'Board footer',
'Search links'		=>	'Hakulinkit',
'Show recent posts'	=>	'Nyt viimeisimmt viestit',
'Show unanswered posts'	=>	'Nyt vastaamattomat viestit',
'Show your posts'	=>	'Omat viestit nkyviin',
'Show subscriptions'	=>	'Nyt tilatut keskusteluaiheet',
'Jump to'		=>	'Vaihda kanavalle',
'Go'			=>	' Mene ',		// submit button in forum jump
'Move topic'		=>      'Move topic',
'Open topic'		=>      'Open topic',
'Close topic'		=>      'Close topic',
'Unstick topic'		=>      'Unstick topic',
'Stick topic'		=>      'Stick topic',
'Moderate forum'	=>	'Moderate forum',
'Delete posts'		=>	'Delete multiple posts',
'Debug table'		=>	'Debug information',

// For extern.php RSS feed
'RSS Desc Active'	=>	'The most recently active topics at',	// board_title will be appended to this string
'RSS Desc New'		=>	'The newest topics at',					// board_title will be appended to this string
'Posted'		=>	'Posted'	// The date/time a topic was started

);
